<?php

namespace Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto;

class DynamicLoanLinkInitiationInput
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'lenderId' => null,
        'walletId' => null,
        'termsAndConditions' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\AcknowledgedLegalTerm',
        'dynamicInput' => null,
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function LenderId(string $data): DynamicLoanLinkInitiationInput
    {
        return new DynamicLoanLinkInitiationInput('lenderId', $data);
    }
    public static function WalletId(string $data): DynamicLoanLinkInitiationInput
    {
        return new DynamicLoanLinkInitiationInput('walletId', $data);
    }
    public static function TermsAndConditions(\Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\AcknowledgedLegalTerm $data): DynamicLoanLinkInitiationInput
    {
        return new DynamicLoanLinkInitiationInput('termsAndConditions', $data);
    }
    public static function DynamicInput(array $data): DynamicLoanLinkInitiationInput
    {
        return new DynamicLoanLinkInitiationInput('dynamicInput', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    